<?php

namespace Drupal\config_provider\Plugin;

/**
 * Class for invoking configuration providers..
 */
interface ConfigCollectorInterface {

  /**
   * Gets all configuration provider plugins.
   *
   * @return \Drupal\config_provider\Plugin\ConfigProviderInterface[]
   *   Configuration providers.
   */
  public function getConfigProviders();

  /**
   * Gets installable configuration from all provider plugins.
   *
   * @return array
   *   An array of configuration data read from the source storage keyed by the
   *   configuration object name.
   */
  public function getInstallableConfig();

}
